#include <stdio.h>

               /**** Machine-and compiler-specific defines ***/

#ifdef __DOS__
#define __MSDOS__
#endif               /* TurboC defines __MSDOS__, Watcom defines __DOS__ */

#ifdef __TURBOC__
#include <alloc.h>
#define halloc(n, s)    farmalloc(((long)n)*(s))
#define hfree  farfree
#endif                           /* TURBO C */

#ifdef __WATCOMC__
#include <malloc.h>
#include <ctype.h>
#endif                           /* Watcom C */

#ifdef __MSDOS__     /*************** DOS SYSTEMS **********************/

#ifndef __386__         /* not dos extender */
#define MAX    8        /* maximum spins */
#define P2MAX  256      /* 2**MAX */
#define MAXBLK 70       /* largest binomial coefficient of order MAX */
#define  T9             /* # transitions in a 9-spin system */
#define LASTMASK
#define MAXHDIM   90    /* biggest matrix possible in 16 bit */
#endif               /* not dos extender */

#ifdef __386__       /* dos extender  */
#define far
#define huge
#define halloc(n, s)  calloc((n), (s))
#define hfree  free
#define  T9    ,43758
#define  LASTMASK ,0xff
#define  MAXHDIM  (MAXBLK)
#define  MAX   9     /* 32 bit version can do 9 spins */
#define  P2MAX 512
#define  MAXBLK 126
#endif               /* dos extender */

#endif      /************************* DOS SYSTEMS ***********************/

#ifndef __MSDOS__    /* This might possibly make it work on non-dos systems */
#define far
#define huge
#define farmalloc malloc
#define farfree   free
#define halloc(n, s)    malloc((n)*(s))
#define hfree     free
#define  T9    ,43758
#define  LASTMASK ,0xff
#define  MAXHDIM  (MAXBLK)
#define  MAX   9
#define  P2MAX 512
#define  MAXBLK 126
#endif               /* not DOS */

#define TRUE	1
#define FALSE	0
#define ERROR  -1

#define ROUND      1e-9    /* consolidate lines closer than this */
#define GREEN      2       /* colours */
#define GREY       7

#define ABORT_KEY  3       /* ctl-C */

#define MININT 5e-5     /* forget transitions weaker than this */
#define ACC    1e-9     /* accuracy parameter. seek this fraction of 
                           smallest j as eigenvalue accuracy */


struct transition {  double de;
                     double intens;
                  };

struct screendef  {    int xpels;
                       int ypels;
                       int crows;
                       int ccols;
                  };


void hardinit(void) ;
void hardfinish(void);
void getscreen(struct screendef *s);
void cls(void);
void clrinp(void);
void cursor(int row, int col);
void prnc(char *s);
int  key(void);
void statmsg(char *f, char *s);
void errmsg(char *f, char *s);
void zzstr(char *s, int n);
int read_file(char *n);
int interactive_input(int nsp);
int qgets(char *b, int size, FILE *f);
double getparm(char *prompt);
double rnh(double x);
double rnl(double x);
void nmrcalc( int nspin, double *freq, double j[MAX][MAX],
     struct transition huge *t);
int bitcount(int i, int n);
int ymeig(int n, double *a, double *e, double eps, int v);
void tssort(struct transition huge *data, int n);
void stickplot(struct transition huge *data, double left, double right,
                     int nt, int hp);
void lorentzplot(struct transition huge *data, double left, double right,
                     int nt, int hp, double fwhm);
void hpout(char *s);
void hpinit(void);
int axis(double left, double right, int hp);
void line (int x1, int y1, int x2, int y2, unsigned char colour);
void screendump (int dotrows, char *filename);
int squob(char *s);
